Require Import bool.
Require Import connectives.
Require Import leibniz.
Require Import logic.
Parameter nat : Type.
Parameter O : nat.
Parameter S : nat -> nat.
Parameter match_nat_type : forall (return_:Type), return_ -> (nat -> return_) -> nat -> return_.
Axiom axiom_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), connectives.equal (return_type) (match_nat_type (return_type) case_O case_S O) case_O.
Definition eq_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), leibniz.leibniz (return_type) (match_nat_type (return_type) case_O case_S O) case_O := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => ((((connectives.equal_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S O)) (case_O)) ((((axiom_match_nat_type_O) (return_type)) (case_O)) (case_S)).
Definition sym_eq_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), leibniz.leibniz (return_type) case_O (match_nat_type (return_type) case_O case_S O) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => ((((leibniz.sym_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S O)) (case_O)) ((((eq_match_nat_type_O) (return_type)) (case_O)) (case_S)).
Axiom axiom_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (match_nat_type (return_type) case_O case_S (S n)) (case_S n).
Definition eq_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (match_nat_type (return_type) case_O case_S (S n)) (case_S n) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S (S n))) (case_S n)) (((((axiom_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
Definition sym_eq_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (case_S n) (match_nat_type (return_type) case_O case_S (S n)) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => fun (n:nat) => ((((leibniz.sym_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S (S n))) (case_S n)) (((((eq_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
Parameter filter_nat_type : forall (return_:Type), (nat -> return_) -> nat -> return_.
Axiom axiom_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), connectives.equal (return_type) (filter_nat_type (return_type) return_ O) (return_ O).
Definition eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ O) (return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((axiom_filter_nat_type_O) (return_type)) (return_)).
Definition sym_eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (return_ O) (filter_nat_type (return_type) return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((eq_filter_nat_type_O) (return_type)) (return_)).
Axiom axiom_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)).
Definition eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((axiom_filter_nat_type_S) (return_type)) (return_)) (n)).
Definition sym_eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (return_ (S n)) (filter_nat_type (return_type) return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((eq_filter_nat_type_S) (return_type)) (return_)) (n)).
Axiom nat_ind : forall (Q:(nat -> Prop)), (Q O) -> (forall (x:nat), (Q x) -> Q (S x)) -> forall (x:nat), Q x.
Parameter eqb : nat -> nat -> bool.bool.
Parameter eqb_body : nat -> nat -> bool.bool.
Axiom axiom_eqb : forall (n:nat), connectives.equal (nat -> bool.bool) (eqb n) (filter_nat_type (nat -> bool.bool) eqb_body n).
Definition eq_eqb : forall (n:nat), leibniz.leibniz (nat -> bool.bool) (eqb n) (filter_nat_type (nat -> bool.bool) eqb_body n) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> bool.bool)) (eqb n)) (filter_nat_type (nat -> bool.bool) eqb_body n)) ((axiom_eqb) (n)).
Definition sym_eq_eqb : forall (n:nat), leibniz.leibniz (nat -> bool.bool) (filter_nat_type (nat -> bool.bool) eqb_body n) (eqb n) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> bool.bool)) (eqb n)) (filter_nat_type (nat -> bool.bool) eqb_body n)) ((eq_eqb) (n)).
Axiom axiom_eqb_body_O : connectives.equal (nat -> bool.bool) (eqb_body O) (fun (m:nat) => match_nat_type (bool.bool) bool.true (fun (q:nat) => bool.false) m).
Definition eq_eqb_body_O : leibniz.leibniz (nat -> bool.bool) (eqb_body O) (fun (m:nat) => match_nat_type (bool.bool) bool.true (fun (q:nat) => bool.false) m) := ((((connectives.equal_leibniz) (nat -> bool.bool)) (eqb_body O)) (fun (m:nat) => match_nat_type (bool.bool) bool.true (fun (q:nat) => bool.false) m)) (axiom_eqb_body_O).
Definition sym_eq_eqb_body_O : leibniz.leibniz (nat -> bool.bool) (fun (m:nat) => match_nat_type (bool.bool) bool.true (fun (q:nat) => bool.false) m) (eqb_body O) := ((((leibniz.sym_leibniz) (nat -> bool.bool)) (eqb_body O)) (fun (m:nat) => match_nat_type (bool.bool) bool.true (fun (q:nat) => bool.false) m)) (eq_eqb_body_O).
Axiom axiom_eqb_body_S : forall (n:nat), connectives.equal (nat -> bool.bool) (eqb_body (S n)) (fun (m:nat) => match_nat_type (bool.bool) bool.false (fun (q:nat) => eqb n q) m).
Definition eq_eqb_body_S : forall (n:nat), leibniz.leibniz (nat -> bool.bool) (eqb_body (S n)) (fun (m:nat) => match_nat_type (bool.bool) bool.false (fun (q:nat) => eqb n q) m) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> bool.bool)) (eqb_body (S n))) (fun (m:nat) => match_nat_type (bool.bool) bool.false (fun (q:nat) => eqb n q) m)) ((axiom_eqb_body_S) (n)).
Definition sym_eq_eqb_body_S : forall (n:nat), leibniz.leibniz (nat -> bool.bool) (fun (m:nat) => match_nat_type (bool.bool) bool.false (fun (q:nat) => eqb n q) m) (eqb_body (S n)) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> bool.bool)) (eqb_body (S n))) (fun (m:nat) => match_nat_type (bool.bool) bool.false (fun (q:nat) => eqb n q) m)) ((eq_eqb_body_S) (n)).
Definition eqb_n_n : forall (n:nat), logic.eq (bool.bool) (eqb n n) bool.true := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => logic.eq (bool.bool) (eqb _x_365 _x_365) bool.true)) ((((sym_eq_eqb) (O)) (fun (y:(nat -> bool.bool)) => logic.eq (bool.bool) (y O) bool.true)) (((((sym_eq_filter_nat_type_O) (nat -> bool.bool)) (eqb_body)) (fun (y:(nat -> bool.bool)) => logic.eq (bool.bool) (y O) bool.true)) (((sym_eq_eqb_body_O) (fun (y:(nat -> bool.bool)) => logic.eq (bool.bool) (y O) bool.true)) ((((((sym_eq_match_nat_type_O) (bool.bool)) (bool.true)) (fun (q:nat) => bool.false)) (fun (y:bool.bool) => logic.eq (bool.bool) y bool.true)) (((logic.refl) (bool.bool)) (bool.true))))))) (fun (x_366:nat) => (((sym_eq_eqb) (S x_366)) (fun (y:(nat -> bool.bool)) => (logic.eq (bool.bool) (eqb x_366 x_366) bool.true) -> logic.eq (bool.bool) (y (S x_366)) bool.true)) ((((((sym_eq_filter_nat_type_S) (nat -> bool.bool)) (eqb_body)) (x_366)) (fun (y:(nat -> bool.bool)) => (logic.eq (bool.bool) (eqb x_366 x_366) bool.true) -> logic.eq (bool.bool) (y (S x_366)) bool.true)) ((((sym_eq_eqb_body_S) (x_366)) (fun (y:(nat -> bool.bool)) => (logic.eq (bool.bool) (eqb x_366 x_366) bool.true) -> logic.eq (bool.bool) (y (S x_366)) bool.true)) (((((((sym_eq_match_nat_type_S) (bool.bool)) (bool.false)) (fun (q:nat) => eqb x_366 q)) (x_366)) (fun (y:bool.bool) => (logic.eq (bool.bool) (eqb x_366 x_366) bool.true) -> logic.eq (bool.bool) y bool.true)) (fun (_x_368:logic.eq (bool.bool) (eqb x_366 x_366) bool.true) => (((((((logic.rewrite_r) (bool.bool)) (bool.true)) (fun (__:bool.bool) => logic.eq (bool.bool) __ bool.true)) (((logic.refl) (bool.bool)) (bool.true))) (eqb x_366 x_366)) (_x_368)))))))) (n).
